package com.example.shelby.healthquest40;

import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

public class Inventory_2 extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_inventory_2);

    }

    public void AtkPot(View view) {
        /**************************************************
         * AtkPot sets up the pop-up window that appears  *
         * when the button for Attack Potions is clicked. *
         **************************************************/
        /***********************************
         * INITIALIZING SHARED PREFERENCES *
         ***********************************/
        SharedPreferences myPreferences = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());

        /************************************
         * INITIALIZING IMAGEVIEWS AND TEXT *
         ************************************/
        ImageView atkpot = new ImageView (this);
        atkpot.setImageResource(R.drawable.atkpot);
        String text = "A bright green potion. It is very cold." + "\n" +
                "Doubles the damage you do for one Quest." + "\n" +
                "Current Quantity: " + (String.valueOf(myPreferences.getInt("ATKPOT_QUANTITY", 0)));

        /****************************
         * SETTING UP POP-UP WINDOW *
         ****************************/
        AlertDialog.Builder alert = new AlertDialog.Builder(this);
        alert.setTitle("Attack Potion"); //set the title of the pop-up window
        alert.setMessage(text); //set the flavor text
        alert.setPositiveButton("OK", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                //do nothing
            }
        });
        alert.setView(atkpot); //set the image to the pop-up
        alert.show(); //show the pop-up
    }

    public void DefPot(View view) {
        /***************************************************
         * DefPot sets up the pop-up window that appears   *
         * when the button for Defense Potions is clicked. *
         ***************************************************/
        /***********************************
         * INITIALIZING SHARED PREFERENCES *
         ***********************************/
        SharedPreferences myPreferences = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());

        /************************************
         * INITIALIZING IMAGEVIEWS AND TEXT *
         ************************************/
        ImageView defpot = new ImageView (this);
        defpot.setImageResource(R.drawable.defensepot);
        String text = "A dark blue potion. It is heavier than it looks." + "\n" +
                "Halves the damage you take for one Quest." + "\n" +
                "Current Quantity: " + (String.valueOf(myPreferences.getInt("DEFPOT_QUANTITY", 0)));

        /****************************
         * SETTING UP POP-UP WINDOW *
         ****************************/
        AlertDialog.Builder alert = new AlertDialog.Builder(this);
        alert.setTitle("Defense Potion"); //set the title for the pop-up
        alert.setMessage(text); //set the flavor text on the pop-up
        alert.setPositiveButton("OK", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                //do nothing
            }
        });
        alert.setView(defpot); //set the image on the pop-up
        alert.show(); //show the pop-up
    }

    public void HealthPot(View view) {
        /****************************************************
         * HealthPot sets up the pop-up window that appears *
         * when the button for Health Potions is clicked.   *
         ****************************************************/
        /***********************************
         * INITIALIZING SHARED PREFERENCES *
         ***********************************/
        SharedPreferences myPreferences = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());

        /************************************
         * INITIALIZING IMAGEVIEWS AND TEXT *
         ************************************/
        ImageView healthpot = new ImageView (this);
        healthpot.setImageResource(R.drawable.healthpot);
        String text = "A comforting red potion. It is warm to the touch."+ "\n" +
                "Restores half your HP." + "\n" +
                "Current Quantity: " + (String.valueOf(myPreferences.getInt("HEALTHPOT_QUANTITY", 0)));

        /****************************
         * SETTING UP POP-UP WINDOW *
         ****************************/
        AlertDialog.Builder alert = new AlertDialog.Builder(this);
        alert.setTitle("Health Potion"); //set the title on the pop-up
        alert.setMessage(text); //set the flavor text on the pop-up
        alert.setPositiveButton("OK", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                //do nothing
            }
        });
        alert.setView(healthpot); //set the image on the pop-up
        alert.show(); //show the pop-up
    }
}
