package com.example.shelby.healthquest40;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

import java.util.Random;

import pl.droidsonroids.gif.GifImageView;

public class Quest extends AppCompatActivity {

    private ProgressBar enemyProgress;
    private ProgressBar heroProgress;
    int enemycurrenthealth = 100;
    int herocurrenthealth = 100;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_quest);

        /*******************************************************
         * INITIALIZING HERO, MONSTER, AND MONSTER NAME ARRAYS *
         *******************************************************/
        int [] characterArray = new int[]{R.drawable.lngblk_blu_olive,
                R.drawable.lngblk_grn_olive, R.drawable.lngblk_brn_olive, R.drawable.lngbrn_blu_olive,
                R.drawable.lngbrn_grn_olive, R.drawable.lngbrn_brn_olive, R.drawable.lngblnd_blu_olive,
                R.drawable.lngblnd_grn_olive, R.drawable.lngblnd_brn_olive, R.drawable.lngrd_blu_olive,
                R.drawable.lngrd_grn_olive, R.drawable.lngrd_brn_olive, R.drawable.shtblk_blu_olive,
                R.drawable.shtblk_grn_olive, R.drawable.shtblk_brn_olive, R.drawable.shtbrn_blu_olive,
                R.drawable.shtbrn_grn_olive, R.drawable.shtbrn_brn_olive, R.drawable.shtblnd_blu_olive,
                R.drawable.shtblnd_grn_olive, R.drawable.shtblnd_brn_olive, R.drawable.shtrd_blu_olive,
                R.drawable.shtgrd_grn_olive, R.drawable.shtgrd_brn_olive, R.drawable.bzblk_blu_olive,
                R.drawable.bzblk_grn_olive, R.drawable.bzblk_brn_olive, R.drawable.bzbrn_blu_olive,
                R.drawable.bzbrn_grn_olive, R.drawable.bzbrn_brn_olive, R.drawable.bzblnd_blu_olive,
                R.drawable.bzblnd_grn_olive, R.drawable.bzblnd_brn_olive, R.drawable.bzrd_blu_olive,
                R.drawable.bzrd_grn_olive, R.drawable.bzrd_brn_olive, R.drawable.lngblk_blu_brn,
                R.drawable.lngblk_grn_brn, R.drawable.lngblk_brn_brn, R.drawable.lngbrn_blu_brn,
                R.drawable.lngbrn_grn_brn, R.drawable.lngbrn_brn_brn, R.drawable.lngblnd_blu_brn,
                R.drawable.lngblnd_grn_brn, R.drawable.lngblnd_brn_brn, R.drawable.lngrd_blu_brn,
                R.drawable.lngrd_grn_brn, R.drawable.lngrd_brn_brn, R.drawable.shtblk_blu_brn,
                R.drawable.shtblk_grn_brn, R.drawable.shtblk_brn_brn, R.drawable.shtbrn_blu_brn,
                R.drawable.shtbrn_grn_brn, R.drawable.shtbrn_brn_brn, R.drawable.shtblnd_blu_brn,
                R.drawable.shtblnd_grn_brn, R.drawable.shtblnd_brn_brn, R.drawable.shtrd_blu_brn,
                R.drawable.shtrd_grn_brn, R.drawable.shtrd_brn_brn, R.drawable.bzblk_blu_brn,
                R.drawable.bzblk_grn_brn, R.drawable.bzblk_brn_brn, R.drawable.bzbrn_blu_brn,
                R.drawable.bzbrn_grn_brn, R.drawable.bzbrn_brn_brn, R.drawable.bzblnd_blu_brn,
                R.drawable.bzblnd_grn_brn, R.drawable.bzblnd_brn_brn, R.drawable.bzrd_blu_brn,
                R.drawable.bzrd_grn_brn, R.drawable.bzrd_brn_brn};

        int [] monsterarray = new int [] { R.drawable.green_slime, R.drawable.blue_slime,
                R.drawable.red_slime, R.drawable.gray_slime, R.drawable.purple_slime,
                R.drawable.gray_wolf, R.drawable.red_wolf, R.drawable.dark_wolf, R.drawable.brown_bear
        };

        String [] monsternamearray = new String [] {"Green Slime", "Blue Slime", "Red Slime",
                "Gray Slime", "Purple Slime", "Gray Wolf", "Red Wolf", "Dark Wolf", "Brown Bear"
        };

        SharedPreferences myPrefs = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
        SharedPreferences.Editor myEditor = myPrefs.edit();

        /*************************************
         * INITIALIZING MONSTER/HERO DISPLAY *
         *************************************/
        GifImageView hero = (GifImageView) findViewById(R.id.hero);
        hero.setImageResource(characterArray[myPrefs.getInt("C_MODEL", 1)-1]);
        GifImageView monster = (GifImageView) findViewById(R.id.enemy);
        monster.setImageResource(monsterarray[myPrefs.getInt("LEVEL", 1)-1]);

        /**********************************************************************
         * TODO: Make this work. Ideally would randomize monsters within      *
         * TODO: a range of five (ex: if the user was level five, it could    *
         * TODO: make any monster in array slot 0-4 appear), so that the user *
         * TODO: was not facing the same monster continuously.                *
         **********************************************************************/
//        Random rand = new Random();
//        int random = rand.nextInt(5);
//        int monsterchoice = (myPrefs.getInt("LEVEL", 0)-random);
//        Toast.makeText(getBaseContext(), monsterchoice, Toast.LENGTH_SHORT).show();
//        if (monsterchoice > 0) {
//            monster.setImageResource(monsterarray[monsterchoice]-1);
//        } else {
//            monsterchoice = myPrefs.getInt("LEVEL", 0);
//            monster.setImageResource(monsterarray[monsterchoice]-1);
//        }

        /****************************
         * INITIALIZING HEALTH BARS *
         ****************************/
        enemyProgress = (ProgressBar) findViewById(R.id.enemyhealthbar);
        heroProgress = (ProgressBar) findViewById(R.id.herohealthbar);
        heroProgress.setProgress(heroProgress.getMax());

        myEditor.putInt("CURRENT_HERO_HEALTH", heroProgress.getMax());
        myEditor.putInt("MAX_HERO_HEALTH", heroProgress.getMax());
        myEditor.putInt("CURRENT_ENEMY_HEALTH", enemyProgress.getMax());
        myEditor.putInt("MAX_ENEMY_HEALTH", enemyProgress.getMax());
        myEditor.commit();

        /***********************************
         * INITIALIZING MONSTER/HERO NAMES *
         ***********************************/
        TextView heroname = (TextView) findViewById(R.id.username_txt);
        heroname.setText(myPrefs.getString("USERNAME", "null"));
        TextView monstername = (TextView) findViewById(R.id.enemyname_txt);
        monstername.setText(monsternamearray[myPrefs.getInt("LEVEL", 1)-1]);
    }


    public void fight(View view) {
        /*************************************************************************************
         * fighting function. will calculate random (but reasonable) damage to both parties. *
         * inflicts damage on the opponent first to negate the possibility of a tie. will    *
         * also reset experience and level if the MAX_EXP is reached.                        *
         *                                                                                   *
         * as of 4/11/17, you will need to hit fight to end the fight if, after using a      *
         * molotov cocktail, the enemy's HP is below zero                                    *
         *************************************************************************************/
        SharedPreferences myPrefs = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
        SharedPreferences.Editor myEditor = myPrefs.edit();

        /***********************************
         * CALCULATING DAMAGE TO THE ENEMY *
         ***********************************/
        Random rand = new Random();
        int en = rand.nextInt(10)+2;
        if (myPrefs.getBoolean("ATKPOT_ACTIVE", false) == true) {
            en = en*2;
        }

        enemycurrenthealth = myPrefs.getInt("CURRENT_ENEMY_HEALTH", 0);
        enemyProgress.setProgress(enemycurrenthealth-en);
        enemycurrenthealth = enemycurrenthealth-en;

        myEditor.putInt("CURRENT_ENEMY_HEALTH", enemycurrenthealth);

        /***********************
         * ENEMY OUT OF HEALTH *
         ***********************/
        if (enemycurrenthealth == 0 || enemycurrenthealth < 0) {
            myEditor.putBoolean("ATKPOT_ACTIVE", false);
            myEditor.putBoolean("DEFPOT_ACTIVE", false);
            myEditor.putBoolean("PSNPOT_ACTIVE", false);

            Random rng = new Random();
            int coinrng = rng.nextInt(10)+5;
            myEditor.putInt("COINS", myPrefs.getInt("COINS", 1000)+(myPrefs.getInt("LEVEL", 1)*coinrng));

            Toast.makeText(getBaseContext(), "You won!", Toast.LENGTH_SHORT).show();

            myEditor.putInt("EXPERIENCE", (myPrefs.getInt("EXPERIENCE", 1)+10));

            /************************
             * CHECK IF LEVELING UP *
             ************************/
            if (myPrefs.getInt("EXPERIENCE", 0) >= myPrefs.getInt("MAX_EXP", 0)) {
                myEditor.putInt("EXPERIENCE", 0);
                if (myPrefs.getInt("LEVEL", 0) == 10) {
                    //do nothing. 10 is the level cap.
                } else {
                    myEditor.putInt("LEVEL", (myPrefs.getInt("LEVEL", 1)+1));
                }
                int newexp = (myPrefs.getInt("MAX_EXP", 100)*2);
                myEditor.putInt("MAX_EXP", newexp);
                myEditor.commit();
            }
            myEditor.commit();
            Intent intent = new Intent(this, MainActivity.class);
            startActivityForResult(intent, 1);
        }
        /*****************************
        * CALCULATING DAMAGE TO HERO *
        ******************************/
        Random random = new Random();
        int herodamage = random.nextInt(10)+(myPrefs.getInt("LEVEL", 0));
        if (myPrefs.getBoolean("DEFPOT_ACTIVE", false) == true) {
            herodamage = herodamage/2;
        }
        herocurrenthealth = myPrefs.getInt("CURRENT_HERO_HEALTH", 0);
        heroProgress.setProgress(herocurrenthealth-herodamage);
        herocurrenthealth = herocurrenthealth-herodamage;

        myEditor.putInt("CURRENT_HERO_HEALTH", herocurrenthealth);
        myEditor.commit();

        /*****************
         * OUT OF HEALTH *
         *****************/
        if (herocurrenthealth == 0 || herocurrenthealth < 0) {
            Toast.makeText(getBaseContext(), "You died! :(", Toast.LENGTH_SHORT).show();
            myEditor.putInt("COINS", myPrefs.getInt("COINS", 0)+10);
            Intent intent = new Intent(this, MainActivity.class);
            startActivityForResult(intent, 1);
        }
    }

    public void inQuestItem(View view) {
        /***********************************************
         * inQuestItem opens the In-Quest Item screen. *
         ***********************************************/
        Intent intent = new Intent(this, inQuestItem.class);
        startActivity(intent);
    }
}